// Copyright (c) 2020-2023 Navibyte (https://navibyte.com). All rights reserved.
// Use of this source code is governed by a “BSD-3-Clause”-style license that is
// specified in the LICENSE file.
//
// Docs: https://github.com/navibyte/geospatial

/// Enums (codes) for geospatial coordinate, geometry types, canvas origin,
/// cardinal direction, DMS type, geo representation and axis order.
///
/// This libary exports a subset of `package:geobase/geobase.dart`.
///
/// Usage: import `package:geobase/codes.dart`
library codes;

export 'src/codes/axis_order.dart';
export 'src/codes/canvas_origin.dart';
export 'src/codes/cardinal_precision.dart';
export 'src/codes/coords.dart';
export 'src/codes/dms_type.dart';
export 'src/codes/geo_representation.dart';
export 'src/codes/geom.dart';
